/**
 * API Error handling
 *
 * @author [Mike Wang]
 * @version 1.0.0
 */
export declare enum ErrorType {
    EMPTY_FIELD = "empty_field",
    ALREADY_EXISTS = "already_exists"
}
/**
 * Parse an API error message in a standard way so it can be handled accordingly
 *
 * @param error
 * @returns
 */
export declare const parseError: (error: any) => {
    type?: undefined;
    msg?: undefined;
    field?: undefined;
} | {
    type: ErrorType;
    msg: (entity: string, field: string, value: string) => string;
    field: any;
};
