/**
 * API Request Definition
 * This utility is responsible for defining how API requests should be made.
 * @author [Vivek Sudarsan]
 * @version 1.0.0
 */
interface IRequestProps {
    resource: Array<string> | string;
    id?: Array<string>;
    method?: 'get' | 'post' | 'put' | 'patch' | 'delete';
    data?: object;
    config?: object;
    keepAlive?: boolean;
}
/**
 * API request handler
 * @param request
 * @returns
 */
declare const apiRequest: (request: IRequestProps) => Promise<any>;
export default apiRequest;
/**
 * Pre-flight handler to hash sensitive data
 * before sending to the server
 * @param request
 */
export declare const preFlightHandler: (requestData: any) => Promise<any>;
