/**
 * Batcher class to batch data and send it to the server
 * @author [Vivek Sudarsan]
 * @version 0.1.0
 */
export declare class Batcher {
    private queue;
    private batchSize;
    private delay;
    private callback;
    private timer;
    /**
     * Create a new Batcher instance with the given batch size and delay
     * @param batchSize
     * @param delay
     */
    constructor(batchSize: number, delay: number, callback: any);
    /**
     * Add data to the queue
     * @param data
     */
    addToQueue(data: any): void;
    /**
     * Send the current batch to the server
     * and clear the queue. Retry failed requests.
     */
    private sendBatch;
}
