/**
 * Constants (phrases, urls etc.)
 * @author [Vivek Sudarsan]
 * @version 0.1.0
 */

export const INTERACTION_CUSTOMERS_EXCLUDE = [
  'rho',
  'xplor',
  'rakuten',
  'arc',
  'madmobile',
];

export const TOUCH_TYPES = {
  VIEW: 'VIEW',
  FORM_FILL: 'FORM_FILL',
  IN_APP_VIEW: 'IN_APP_VIEW',
};

export const TRACK_TYPE_MAP: any = {
  VIEW: 'session',
  FORM_FILL: 'forms',
  IN_APP_VIEW: 'inAppView',
};

export const INTERACTION_TYPES: any = {
  VIEW: 'VIEW',
  HIGHLIGHT: 'HIGHLIGHT',
  CLICK: 'CLICK',
  SCREENSHOT: 'SCREENSHOT',
  HOVER: 'HOVER',
  COPY: 'COPY',
};

export const URL: { [key: string]: { [key: string]: string } } = {
  contact: {
    GET: '',
  },
};

export const THIRD_PARTY_SCRIPTS: any = {
  fullContact: (key: string) => `(function (w, d, s, o, f, js, fjs) {
    w['FCObject'] = o; w[o] = w[o] || function () { (w[o].q = w[o].q || []).push(arguments) };
    js = d.createElement(s), fjs = d.getElementsByTagName(s)[0];
    js.id = o; js.src = f; js.async = 1; fjs.parentNode.insertBefore(js, fjs);
    }(window, document, 'script', 'fc', 'https://tags.fullcontact.com/anon/fullcontact.js'));
    fc('init','${key}');`,
  vector: `!function(e,r){try{if(e.vector)return void console.log("Vector snippet included more than once.");var t={};t.q=t.q||[];for(var o=["load","identify","on"],n=function(e){return function(){var r=Array.prototype.slice.call(arguments);t.q.push([e,r])}},c=0;c<o.length;c++){var a=o[c];t[a]=n(a)}if(e.vector=t,!t.loaded){var i=r.createElement("script");i.type="text/javascript",i.async=!0,i.src="https://cdn.vector.co/pixel.js";var l=r.getElementsByTagName("script")[0];l.parentNode.insertBefore(i,l),t.loaded=!0}}catch(e){console.error("Error loading Vector:",e)}}(window,document);`,
};

export const THIRD_PARTY_REQUEST_URLS = ['https://api.fullcontact.com'];

export const THIRD_PARTY_URLS = {
  sentry:
    'https://0871a6fe36a50eb2e1521fdbcb2a92ec@o4505722078560256.ingest.sentry.io/4505722080395264',
};

export const EXCLUDED_FORM_TYPES = ['password', 'hidden'];

export const EXCLUDED_FORM_NAMES = ['key', 'token', 'secret', 'password'];

export const SENSITIVE_DATA_KEYS = [
  'firstname',
  'firstName',
  'first_name',
  'fname',
  'first-name',
  'name',
  'lastname',
  'lastName',
  'last_name',
  'lname',
  'last-name',
  'name',
  'email',
  'email-3',
  'Email-Address',
  'Email-Address-2',
  'email_address',
  'emailAddress',
  'work_email',
  'workEmail',
  'work-email',
  'work_email_address',
  'workemailaddress',
  'emailaddress',
  'contact_email',
  'contactemail',
  'contact_email_address',
  'contactemailaddress',
  'phone',
  'phone-number',
  'phoneNumber',
  'contactPhone',
  'contact-phone',
  'contact_phone',
  'contactPhoneNumber',
  'phone_number',
  'tel',
  'telephone',
  'contactTelephone',
  'contact-telephone',
  'contact_telephone',
  'contactPhoneNumber',
  'telephone_number',
  'contactNumber',
  'contact-number',
  'contact_number',
  'mobileNumber',
  'mobile-number',
  'mobile_number',
  'mobile-phone',
  'mobilePhone',
  'mobileContact',
  'mobile-contact',
];

export const FORM_NAMES: any = {
  email: ['email', 'mail', 'contact'],
  name: ['name-', 'name_'],
  firstName: ['first', 'fname'],
  lastName: ['last', 'lname'],
  company: ['company', 'business', 'employer'],
  title: ['job', 'position', 'role'],
  phone: ['tel', 'telephone', 'mobile'],
};

export const TEST_FORM_NAMES: any = [
  'companyname',
  'company_name',
  'company-name',
  'company',
  'business',
  'business_name',
  'businessname',
  'business-name',
  'employer',
  'employername',
  'employer_name',
  'firstname',
  'first_name',
  'fname',
  'first-name',
  'name',
  'lastname',
  'last_name',
  'lname',
  'last-name',
  'name',
  'email',
  'email-3',
  'Email-Address',
  'Email-Address-2',
  'email_address',
  'work_email',
  'workEmail',
  'work-email',
  'work_email_address',
  'workemailaddress',
  'emailaddress',
  'contact_email',
  'contactemail',
  'contact_email_address',
  'contactemailaddress',
];

export const HEARBEAT_INTERVAL = 5000;

export const allElementTypes = [
  'p',
  'h1',
  'h2',
  'h3',
  'h4',
  'h5',
  'h6',
  'text',
  'article',
  'section',
  'blockquote',
  'underline',
  'ul',
  'ol',
  'li',
  'figure',
  'figcaption',
  'strong',
  'div',
  'span',
  'main',
  'section',
  'aside',
  'header',
  'b',
];

export const titleElementTypes = ['h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'strong'];

export const containerElementTypes = ['div', 'span'];

export const buttonElementTypes = ['button', 'a'];

export const imageElementTypes = ['img'];

export const documentElementTypes = ['document', 'body'];

export const textElementTypes = [
  'text',
  'p',
  'li',
  'article',
  'span',
  'b',
  'figcaption',
  'blockquote',
  ...titleElementTypes,
];

export const IGNORED_CLASSES = ['tags', 'tag-list', 'tag'];

export const IGNORED_PHRASES = [
  'related posts',
  'related articles',
  'table of contents',
  'join our newsletter',
  'about the author',
  'more stories',
  'privacy policy',
  'terms and conditions',
  'terms of service',
  'schedule a demo',
  'book a demo',
  'schedule with us',
  'request a demo',
  "let's chat",
  'frequently asked questions',
  'last edited',
  'last updated',
  '©',
];
